package codescannerwrapper;

import com.budiyev.android.codescanner.CodeScannerView;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;
import anywheresoftware.b4a.BA.Permissions;

import anywheresoftware.b4a.BA.Events;
//import android.view.MotionEvent;

//import android.graphics.Color;
//import android.graphics.Typeface;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;
//import android.view.Gravity; 

//import android.util.Log;
//import android.view.ViewTreeObserver;

//import android.media.AudioFormat;
//import android.media.AudioRecord;
//import android.media.MediaRecorder;

import java.util.ArrayList;
import java.util.List;
//import java.util.Timer;
//import java.util.TimerTask;

//import android.os.Build;
import android.os.Bundle;


import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;

import com.budiyev.android.codescanner.CodeScanner;
import com.budiyev.android.codescanner.DecodeCallback;
import com.google.zxing.Result;
import android.support.annotation.NonNull;
import android.widget.Toast;


@ActivityObject
@Events(values={"scan_result(result As String)"})
@Author("Github: Yuriy Budiyev, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("CodeScannerView")
@DependsOn(values={"com.android.support:support-annotations", "ZxingLatest"})
@Permissions(values={"android.permission.CAMERA"})
public class codescannerWrapper extends ViewWrapper<CodeScannerView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private CodeScannerView cv;
	private CodeScanner mCodeScanner;

	
	

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new CodeScannerView(ba.context, null);
        this.setObject(cv);
		
        mCodeScanner = new CodeScanner(ba.applicationContext, cv);
        addListener1();

 	}
	
	

      private void addListener1() {
		  
        mCodeScanner.setDecodeCallback(new DecodeCallback() {
            @Override
            public void onDecoded(@NonNull final Result result) {
                ba.activity.runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
					  if (toastmessage == true)	
                        Toast.makeText(ba.applicationContext, result.getText(), Toast.LENGTH_LONG)
                                .show();
								

						  if (ba.subExists(eventName + "_scan_result")) {
							ba.raiseEventFromDifferentThread(getObject(), null, 0, eventName + "_scan_result", true, new Object[] {result.getText()});
						  }
								
                    }
                });
            }
        });
        cv.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                mCodeScanner.startPreview();
            }
        });
	}
	
    public void stopPreview() {
        mCodeScanner.stopPreview();
		mCodeScanner.releaseResources();
    }	


    /**
     * Set whether frame is square or a rectangle
     *
     */
    public void setSquareFrame(boolean squareFrame) {
        cv.setSquareFrame(squareFrame);
		cv.invalidate();
    }

    /**
     * Set color of the space outside of the framing rect
     *
     */
    public void setMaskColor(int color) {
        cv.setMaskColor(color);
		cv.invalidate();
    }

    /**
     * Set color of the frame
     *
     */
    public void setFrameColor(int color) {
        cv.setFrameColor(color);
		cv.invalidate();
    }

    /**
     * Set frame width
     *
     */
    public void setFrameWidth(int width) {
        cv.setFrameWidth(width);
		cv.invalidate();
    }

    /**
     * Set length on the frame corners
     *
     */
    public void setFrameCornersSize(int size) {
        cv.setFrameCornersSize(size);
		cv.invalidate();
    }
	
	private boolean toastmessage = true;
    /**
     * Show or dont show the Toast Message
     * Default value is set to True
     */
    public void setShowToastMessage(boolean toastmessage) {
        this.toastmessage = toastmessage;
    }	
	
 		
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	


   
}
